#include "itrax.h"

#define MAXVARNAME 128

LONG   EXPENTRY EXPORT 
GetStem(PSZ name, LONG argc, PRXSTRING argv, PSZ queue, PRXSTRING  retstr )
{
	char err[128];
	int i, j, n, rc;
	SHVBLOCK shvb;
	char varname[MAXVARNAME];
	char *ibuf;
	ULONG stemlen;
	
	queue = queue;
	argv = argv;
	
	sprintf(err, "REXX (%s),", name);

	if (argc != 2) {
		printf ("%s end of input, len = %d\n", argv[0].strptr, argv[0].strlength);
		return 0;
	}

	n = atoi (argv[0].strptr);
	printf ("allocating %d elements\n", n);

	ibuf = (char *) malloc(n+1);

	for (i = 0, j = 0; i < n; ++i)
	{
		if (j > 9)
			j = 0;
		ibuf[i] = '0' + j++;
		ibuf[i+1] = 0;
	}

	printf ("%s\n(before), %d els\n", ibuf, strlen(ibuf));
	
	strncpy(varname, argv[1].strptr, MAXVARNAME-1);
	stemlen = argv[1].strlength;
	strupr(varname);                 /* uppercase the name         */
	
	if (varname[stemlen-1] != '.') { // if no trailing dot, add it
		varname[stemlen++] = '.';
	}
	
	sprintf(varname+stemlen, "%d", 1);

	shvb.shvnext = NULL;
	
	shvb.shvname.strptr = varname;
	shvb.shvname.strlength = strlen(varname);
	shvb.shvnamelen = shvb.shvname.strlength;
	
	shvb.shvvalue.strptr = ibuf;
	shvb.shvvalue.strlength = strlen(ibuf);
	shvb.shvvaluelen = strlen(ibuf);
	shvb.shvcode = RXSHV_SET;
	shvb.shvret = 0;
		
	if (RexxVariablePool(&shvb) == RXSHV_BADN) {
		printf ("shit happened\n");
		free(ibuf);
		return 1;
	}
	
	sprintf(ibuf, "%d", 1);
	varname[stemlen] = '0';
	varname[stemlen+1] = 0;
	
	shvb.shvnext = NULL;
	
	shvb.shvname.strptr = varname;
	shvb.shvname.strlength = stemlen+1;
	shvb.shvnamelen = stemlen+1;
	
	shvb.shvvalue.strptr = ibuf;
	shvb.shvvalue.strlength = strlen(ibuf);
	shvb.shvvaluelen = strlen(ibuf);
	shvb.shvcode = RXSHV_SET;
	shvb.shvret = 0;
	
	rc = RexxVariablePool(&shvb);

	free (ibuf);

	if (rc == RXSHV_BADN) {
		printf ("shit happened\n");
		return 1;
	}
	
	return 0;                        
}
